---
title: MediaDeviceInfo.groupId
slug: Web/API/MediaDeviceInfo/groupId
tags:
  - API
  - Device
  - Input
  - Media
  - MediaDevicesInfo
  - Property
  - groupId
  - output
---
<p>{{APIRef("Media Capture")}}</p>

<p><span class="seoSummary">The <strong><code>groupId</code></strong> readonly property of the {{domxref("MediaDeviceInfo")}} interface returns a {{domxref("DOMString")}} that is a group identifier.</span> Two devices have the same group identifier if they belong to the same physical device; for example, a monitor with both a built-in camera and microphone.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>groupID</em> = <em>mediaDeviceInfo</em>.groupId;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} which uniquely identifies the group of related devices to which this device belongs.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Capture','#dom-mediadeviceinfo-groupid','groupId')}}</td>
   <td>{{Spec2('Media Capture')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>In this example, we assemble a list of the devices which are part of the same group as a given device. This might be used to produce a user interface that gathers associated devices together for presentation purposes, or to make it easy for the user to choose to use the built-in camera and microphone on the same display at the same time.</p>

<pre class="brush: js">const getDeviceGroup = mainDevInfo =&gt; {
  let devList = [];

  navigator.mediaDevices.enumerateDevices()
  .then(devices =&gt; {
    devices.forEach(device =&gt; {
      if (device.groupId === mainDevInfo.groupId) {
        devList.push(device);
      }
    });
  });

  return devList;
};
</pre>

<p>The <code>getDeviceGroup()</code> function takes as input the <code>MediaDeviceInfo</code> object describing the device for which a group list is to be built. The function starts by initializing the result array, <code>devList</code>, to be an empty array.</p>

<p>Then {{domxref("MediaDevices.enumerateDevices", "navigator.mediaDevices.enumerateDevices()")}} is called to get the list of all media devices. Once the promise resolves, we walk the list using {{jsxref("Array.forEach", "forEach()")}}. For each device, if its {{domxref("MediaDeviceInfo.groupId", "groupId")}} matches the main device's <code>groupId</code>, we push the {{domxref("MediaDeviceInfo")}} object onto the list.</p>

<p>Finally, the list, which now contains a <code>MediaDeviceInfo</code> object for each device in the same group, is returned to the caller.</p>

<p>This could be altered easily to either leave out the passed-in device from the returned list, or to place it at the top of the list, by comparing the two objects' {{domxref("MediaDeviceInfo.deviceId", "deviceId")}} values, only pushing the device onto the result list if it doesn't match.</p>

<p>This version of the example puts the passed-in device at the top of the result list, then adds any other members of the group that are found:</p>

<pre class="brush: js">const getDeviceGroup = mainDevInfo =&gt; {
  let devList = [mainDevInfo];

  navigator.mediaDevices.enumerateDevices()
  .then(devices =&gt; {
    devices.forEach(device =&gt; {
      if ((device.groupId === mainDevInfo.groupId) &amp;&amp;
          (device.deviceId !== mainDevInfo.deviceId)) {
        devList.push(device);
      }
    });
  });

  return devList;
};</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MediaDeviceInfo.groupId")}}</p>
</div>
